import java.sql.*;
import com.acme.resource.*;


// Wrapper per la classe Department

public final class DepartmentWrap extends Wrapper 
{

 public DepartmentWrap()
 {
 	_type = "O_DEPARTMENT"; 
 }
 
 public DepartmentWrap(Department obj)
 {
 	this();
    this._obj = obj;
 }
 
 public void readSQL(SQLInput stream, String typeName) 
 {
  try
  {

System.out.println("## Department WRAP ENTER READ SQL");
System.out.println("## TYPE NAME : " + typeName);
  long depno = stream.readLong();
  String depname = stream.readString(); 
  String loc = stream.readString();
  
  java.util.ArrayList _list = new java.util.ArrayList();
  java.sql.Array array;
  Object[] objs;
  int i;

  //_list.clear();

  System.out.println("READ ARRAY");

  array = stream.readArray();

  System.out.println("GET VARIABLES");

  objs = (Object[])array.getArray(ResourceManager.getInstance().getMap());

  System.out.println("OBJ : " + objs);
  System.out.println("NUM : " + objs.length);
  _list.ensureCapacity(objs.length);

  for (i = 0; i < objs.length; i++)
  {
  	try
  	{
  		_list.add(((EmployeeWrap)objs[i])._obj);
  	} 
  	catch (NullPointerException e)
  	{
  		System.out.println("JDBC PROBLEM : " + e.getMessage());
  	} 
  } 

  System.out.println(_list);

  Employee[] emps = (Employee[])_list.toArray(new Employee[0]);
    
  _obj = new Department(depno, depname, loc, emps);
  
System.out.println("## Department WRAP EXIT READ SQL\n");    
  }
  catch(Exception e)
  {
    e.printStackTrace();
  }
  
 }
 
 public void writeSQL(SQLOutput stream) 
 {
  System.out.println("## Department WRAP ENTER WRITE SQL");
  try
  {
    if(_obj == null)
      System.out.println("Department WRAP OBJ == NULL");
     
    Department obj = (Department)_obj;
    
	stream.writeLong(obj.depno);
  	stream.writeString(obj.depname); 
  	stream.writeString(obj.loc);
	
  	EmployeeWrap[] vars_wraps = new EmployeeWrap[obj.emps.length];

  	for (int i = vars_wraps.length - 1; i >= 0; i--)
  		vars_wraps[i] = new EmployeeWrap(obj.emps[i]);

	Connection _conn = com.acme.resource.ResourceManager.getInstance().getNativeConnection();
	
	oracle.sql.ArrayDescriptor v_ard = new oracle.sql.ArrayDescriptor("A_EMPLOYEE", _conn);
  	oracle.sql.ARRAY v_array = new oracle.sql.ARRAY(v_ard, _conn, vars_wraps);

  	stream.writeArray(v_array);
	
	
  }
  catch(Exception e)
  {
    e.printStackTrace();
  }

System.out.println("## Department WRAP EXIT WRITE SQL\n");
 }
}