
package com.acme.resource;

import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Connection;

import java.util.Hashtable;
import java.util.Map;

import EmployeeWrap;
import DepartmentWrap;


/**
 * Connection, DataSource und
 * Connection Map Verwaltung
 *
 *
 * @author CDR
 * @version #@(#)[version], [crtime]
 */
public final class ResourceManager
{

	private static final java.util.Map map = new Hashtable();					     // SQLData Wrapper Map
	private static final ResourceManager instance = new ResourceManager(); // Singleton

	/**
	 * Konstruktor
	 *
	 * @author CDR
	 */
	private ResourceManager()
	{
		map.put("O_EMPLOYEE", EmployeeWrap.class);
		map.put("O_DEPARTMENT", DepartmentWrap.class);
	}

	/**
	 * Singleton
	 *
	 * @return
	 * @author CDR
	 */
	public static final ResourceManager getInstance()
	{
		return instance;
	}

	/**
	 * Liefert die Connection Map zurck
	 *
	 * @return
	 * @author CDR
	 * *********************************************************************************
	 * Historie:
	 * CDR,  18.01.01:                                     .
	 */
	public final Map getMap()
	{
		return map;
	}

  /**
   * Liefert die sql.Connection von der BEA-Connection
   *
   * @return      Connection
   * @exception   DataSourceNotInitialized, NoConnection
   * @author TFR
   ****************************************************************************
   * Historie:
   * CDR, 15.05.2001: erstellt
   */
  public final Connection getNativeConnection()
  {
  	  String url = "jdbc:oracle:thin:@brucaliffo:1521:ORADB";
  	  String user = "scott";
	  String pass = "tiger";
      
	  try 
      {
	    DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
        return DriverManager.getConnection(url, user, pass);
      }
      catch ( Exception e )
      {
		e.printStackTrace();
		return null;
      }
    }
}