
import java.sql.*;
import java.util.*;
import java.io.*;

/*
 * SET EMPLOYEE: scrive un oggetto di tipo Employee nel DB
 */


public final class SetEmployees
{
  String url = "jdbc:oracle:thin:@brucaliffo:1521:ORADB";
  String user = "scott";
  String pass = "tiger";
  
  /*
   *  Costruttore 
   */
  public static SetEmployees getInstance()
  {
    return new SetEmployees();
  }
  
  
 /*
  *  Restituisce la Type Map 
  */
  final Hashtable getMap()
  {
    Hashtable map = new Hashtable();
    
	map.put("O_EMPLOYEE", EmployeeWrap.class);
    return map;
  }
  
  
  /*
   *  Main 
   */
    public static final void main(String[] args)
  {
        
	try
	{
		  
    	SetEmployees.getInstance().execute("{? = call P_TEST.set_employee(?)}", "A_EMPLOYEE");	
		// Controlliamo se nella lista degli aggiunti ci sia anche il nostro
		//GetAllEmployee.main(null);
	}
    

		catch (SQLException sqle)
		{
		  sqle.printStackTrace();
		}
		catch(Exception e)
		{
		  e.printStackTrace();
		}
   
  }
  
  /*
   *  Chiama la Stored Procedure
   */
  public final void execute(String procedure, String type) throws Exception
  {
      
    DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
    
	//connessione
    Connection conn = DriverManager.getConnection(url, user, pass);
    Hashtable map = SetEmployees.getInstance().getMap();
    conn.setTypeMap(map);
    
	//statement
    CallableStatement statement = conn.prepareCall
    (
      conn.nativeSQL(procedure)
    );
    
    System.out.println("PROCEDURE : " + procedure);
    System.out.println("TYPE : " + type);
	
	EmployeeWrap[] wraps = new EmployeeWrap[5];
	for(int i = 4; i >=0; i--)
	{
		Employee the_emp = new Employee(-1, "NAME" + i, "JOB" + i, 5, new java.sql.Date(System.currentTimeMillis()), 0.00D, 2D, 10);
		wraps[i] = new EmployeeWrap(the_emp);
	}

	// registrazione parametri di IN ed OUT
	oracle.sql.ArrayDescriptor emps_ard = new oracle.sql.ArrayDescriptor(type, conn);
	oracle.sql.ARRAY emps_array = new oracle.sql.ARRAY(emps_ard, conn, wraps);
	((oracle.jdbc.driver.OracleCallableStatement)statement).setArray(2, emps_array);
	
	statement.registerOutParameter(1, oracle.jdbc.driver.OracleTypes.ARRAY, "A_NUMBER");
			 
    statement.execute();
    
    // legge la Primary Key assegnata all'oggetto 
   ResultSet rs = statement.getArray(1).getResultSet();  
   
   // il result set contiene
   // 1 - indice dell'array
   // 2 - valore dell'elemento.
   while (rs.next())
   	System.out.println("PKEY " + rs.getInt(1) + " = " + rs.getLong(2)); 
	  
    statement.close();
    conn.close();
  }
  
 
}