import java.lang.reflect.*;

public final class Snoopy
{
	private static final Snoopy snoopy = new Snoopy();
	
	private Snoopy()
	{
//		System.setSecurityManager(
//			new SecurityManager()
//			{
//				public final void checkPermission(java.security.Permission perm) throws SecurityException
//				{
//					System.out.println(perm);
//					if(perm.implies(new RuntimePermission("setSecurityManager")))
//						throw new SecurityException();
//				}
//				
//				public final void checkPermission(java.security.Permission perm, Object context) throws SecurityException
//				{
//					System.out.println(perm + " - " + context);
//				}
//			}
//		);
	}
	
	public static String snoop(Object o)
	{
		if (o == null) return "";
		
		System.out.println(o);
		
		//new ReflectPermission("suppressAccessChecks");
		
		Class c = o.getClass();
		//System.out.println("CLASS NAME : " + c.getName());
		
		if(c.isPrimitive())
			return o.toString();
		
		return snoopy.snoop(o, new StringBuffer()) + "\n";	
	}
	
	private String snoop(Object o, StringBuffer sb)
	{
		if (o == null)
		{
			sb.append("\tNULL");
			return sb.toString();
		}
		
		Class c = o.getClass();
		String cn = c.getName();
		//System.out.println("CLASS NAME : " + cn);
		if (c.isPrimitive() || cn.startsWith("java."))
		{
			sb.append("\t" + cn + "\t : " + o);
			return sb.toString();
		}
		
		sb.append(cn + " ");
			
		if (c.isArray())
		{
			int length = Array.getLength(o);
			for(int i = 0; i<length; i++ )
			{
				sb.append("\n" + i + ") ");
				snoop(Array.get(o,i), sb);
			}
			sb.append("\n");
			return sb.toString();
		}
		
		Field[] fields = c.getDeclaredFields();
		for(int i = fields.length -1; i>=0; i--)
		{
			try
			{
				Field f = fields[i];
				String fname = f.getName();
				if(fname.length() < 4)
					fname = fname + " \t";
				
				sb.append("\n" + Modifier.toString(f.getModifiers()) + " " + fname + " ");
				//System.out.println(f.get(o));
				snoop(f.get(o), sb);
			}
			catch(Exception e)
			{
				//e.printStackTrace();
				sb.append("\t#Access Denied#");
			}
		}
		
		return sb.toString();
	}
	
}

